%% Parameters to set manually
% parameters for automatic/manual evaluation
automaticSaveBool=false;
automaticProcessBool=false;

% parameters for the convolution to calculate the model function to fit
model.linkerRad=20;                     % radius of the linker, dyes can only be positioned a sphere surfaces around the epitopes
model.multiPrecBool=true;               % calculate the average of the Gaussian distributions derived from the individual localizations precision values
model.locPrecision=[];                  % given standard deviation of the localization precision, if empty or zero, it will take the average of the STDs of the localizations
model.iterGaussianConvBool=false;       % whether the the algorithm should apply additional Gaussian smearing beside the localization precison, can be used for the "gap" structure, the STD of this one is iterated

% select the type of the model function to fit
% model.modelFuncType='Circle';           % dye density from projecting a circle, for filled tubes
% model.modelFuncType='Disk';             % dye density from projecting a disk, for hollow tubes
model.modelFuncType='Gaussian';         % dye density following Gaussian distribution
% model.modelFuncType='Lorentzian';       % dye density following Lorentzian distribution
% model.modelFuncType='Rectangular';      % dye density following top-hat distribution
% model.modelFuncType='Gap';              % dye density following negative top-hat distribution with adittional rims at the edges

% string variable for whether the curve fitting should be executed on a double line or on a single line or on a gap
model.sampleType='single line';
%model.sampleType='double lines';
%model.sampleType='gap';

% type of the dye distribution caused by the linker, "sphere" or "Gaussian"
model.linkerType='sphere';
%model.linkerType='Gaussian';

% some parameters for the gap fitting
model.densFuncSize_init=130;
model.rimWidth=50;

% might need some love, in the "rainSTORM_extras_lineDiameter" there is "PSFmax"
% allowed fitted Gaussian STD range
clearing.PSFSizeMin=0.8;
clearing.PSFSizeMax=1.5;

averageDistBool=false;  % boolean for whether the distances belonging to different line should be catenated (false) or should be a handled seperately, the "Concatenate" button in the GUI

%% reading the histogram data files
histFullFileNames=[];
% pop-up window for opening one or several files
[histDataFileNames, histDataFilePath]= uigetfile({'*.mat'}, 'Open the histogram data files.','MultiSelect','on');
% creating a cell list from the selected files
if histDataFilePath==0
    disp('User cancelled selection');
else
    % number of the chosen histogram data files
    if iscell(histDataFileNames)
        N_histDataFiles=numel(histDataFileNames);   % if multiple files were chosen, the names are stored in a cell array
    else
        N_histDataFiles=1;      % if a single file was chosen, the name is stored in a string
    end
    histFullFileNames=cell(1,N_histDataFiles);
    if N_histDataFiles==1
        %disp(['Regex selected ', fullfile(sectionsPath,sectionDataFiles(idxSection).name)]);
        [~,sectionName,~]=fileparts(histDataFileNames);
        histFullFileNames{1}=fullfile(histDataFilePath, histDataFileNames);
    elseif N_histDataFiles>1
        for idxSection = 1:N_histDataFiles
            %disp(['Regex selected ', fullfile(sectionsPath,sectionDataFiles(idxSection).name)]);
            [~,sectionName,~]=fileparts(histDataFileNames{idxSection});
            histFullFileNames{idxSection}=fullfile(histDataFilePath, histDataFileNames{idxSection});
        end
    end
end

%% calling the line diameter fitting tools
[~] = rainSTORM_extras_lineDiameter_fit(histFullFileNames, clearing, model, averageDistBool, automaticSaveBool, automaticProcessBool);
